$! make xhtml under VMS
$!
$!
$! Look for the compiler used
$!
$ htmlwp = "public$root:[xtools.xutil.mosaic.libhtmlw]"
$ ccopt = "/include=''htmlwp'"
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  ccopt = "/prefix=all"+ccopt
$  comp  = "__decc__=1"
$  if f$trnlnm("SYS").eqs."" then define sys sys$library:
$ else
$  if f$search("SYS$SYSTEM:DECC$COMPILER.EXE").eqs.""
$   then
$    comp  = "__vaxc__=1"
$    if f$trnlnm("SYS").eqs."" then define sys sys$library:
$   else
$    if f$trnlnm("SYS").eqs."" then define sys decc$library_include:
$    ccopt = "/decc/prefix=all"+ccopt
$    comp  = "__decc__=1"
$  endif
$ endif
$!
$!      Build the option-file
$!
$ open/write optf xhtml.opt
$ write optf "xhtml"
$ write optf "xfile"
$ write optf "xform"
$ write optf "xheader"
$ write optf "xmarkup"
$ write optf "xstyles"
$ write optf "xviewer"
$ write optf "Identification=""Xhtml 1.1"""
$ write optf "x11vms:xvmsutils.olb/lib"
$ write optf "''htmlwp'libhtmlw.olb/lib"
$!
$!
$!  Find out which X-Version we're running.  This will fail for older
$!  VMS versions (i.e., v5.5-1).  Therefore, choose DECWindows XUI for
$!  default.
$!
$ On Error Then GoTo XUI
$ @sys$update:decw$get_image_version sys$share:decw$xlibshr.exe decw$version
$ if f$extract(4,3,decw$version).eqs."1.0"
$ then
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.1"
$ then
$   write optf "sys$share:decw$xmlibshr.exe/share"
$   write optf "sys$share:decw$xmulibshr.exe/share"
$   write optf "sys$share:decw$xtshr.exe/share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.2"
$ then
$   write optf "sys$share:decw$xmlibshr12.exe/share"
$   write optf "sys$share:decw$xmulibshrr5.exe/share"
$   write optf "sys$share:decw$xtlibshrr5.exe/share"
$ endif
$ GoTo MAIN
$!
$XUI:
$!
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$MAIN:
$!
$ write optf "sys$share:decw$xlibshr.exe/share"
$ close optf
$!
$! Build the thing plain or with mms
$!
$ write sys$output "Compiling Xhtml sources ..."
$ if f$search("SYS$SYSTEM:MMS.EXE").eqs.""
$  then
$   CALL MAKE xfile.OBJ "CC ''CCOPT' xfile" -
              xfile.c xhtml.h xfile.h xheader.h xstyles.h xviewer.h
$   CALL MAKE xform.OBJ "CC ''CCOPT' xform" -
              xform.c xhtml.h xfile.h xheader.h xform.h
$   CALL MAKE xheader.OBJ "CC ''CCOPT' xheader" -
              xheader.c xhtml.h xfile.h xheader.h xmarkup.h xviewer.h
$   CALL MAKE xhtml.OBJ "CC ''CCOPT' xhtml" -
              xhtml.c xhtml.h xfile.h xheader.h xstyles.h xviewer.h
$   CALL MAKE xmarkup.OBJ "CC ''CCOPT' xmarkup" -
              xmarkup.c xhtml.h xheader.h xmarkup.h 
$   CALL MAKE xstyles.OBJ "CC ''CCOPT' xstyles" -
              xstyles.c xhtml.h xfile.h xheader.h xstyles.h xmarkup.h
$   CALL MAKE xviewer.OBJ "CC ''CCOPT' xviewer" -
              xviewer.c xhtml.h xfile.h xviewer.h
$   write sys$output "Linking xhtml..."
$   call make xhtml.exe "LINK xhtml.opt/opt" *.obj
$  else
$   mms/macro=('comp',inc="''htmlwp'")
$  endif
$ write sys$output "Xhtml build completed"
$ exit
$!
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE
